var Builder = require('./Builder');
var inherits = require('inherits');

function RangeBuilder() {
    this.reset();
};

module.exports = RangeBuilder;
inherits(RangeBuilder, Builder);

RangeBuilder._default = {
    host:'',
    name:'',
    relay:''
};

// --- External API ---
RangeBuilder.createBlankRange = function () {
    return Builder.blankCopy(this._default);
};

RangeBuilder.sanitizeRange = function (rawRange) {
    return Builder.sanitize(rawRange, this._default);
};

RangeBuilder.prototype.getRange = function () {
    return this.getObject();
};

RangeBuilder.prototype.setRange = function (range) {
    this.setObject(range);

    return this;
};

// --- Fine grained setters ---
RangeBuilder.prototype.setHost = function (host) {
    this._object.host = host;

    return this;
};

RangeBuilder.prototype.setName = function (name) {
    this._object.name = name;

    return this;
};

RangeBuilder.prototype.setRelay = function (relay) {
    this._object.relay = relay;

    return this;
};
