var ShotRenderer = require('./ShotRenderer');
var ISSFSilhouetteFinalPistolTargetRenderer = require('./ISSFSilhouetteFinalPistolTargetRenderer');

function ISSFSilhouetteFinalPistolShotRenderer() {
    ShotRenderer.prototype.constructor.apply(this);
}

ISSFSilhouetteFinalPistolShotRenderer.prototype = new ShotRenderer();
ISSFSilhouetteFinalPistolShotRenderer.prototype.constructor = ISSFSilhouetteFinalPistolShotRenderer;
module.exports = ISSFSilhouetteFinalPistolShotRenderer;

ISSFSilhouetteFinalPistolShotRenderer.prototype.initialize = function () {
    ShotRenderer.prototype.initialize.apply(this);

    this.style.markerSize = 0.025;
    this.style.missedMarkerColor = this.style.lastMarkerColor;
    this.style.hitMarkerColor = this.style.markerColor;
};

ISSFSilhouetteFinalPistolShotRenderer.prototype.drawShots = function () {
    // draw first n-1 shots
    var i = 0;
    var targetSpacing = ISSFSilhouetteFinalPistolTargetRenderer.TARGET_SPACING;
    var targetWidth = (1 - 6*targetSpacing)/5;

    for (var idx in this.shots) {
        var shot = this.shots[idx];
        var j = 4 - i;

        if (shot.value !== '-1' && !(shot.value === '0' && shot.x === 0 && shot.y === 0)) {
            this.drawShot({
                x: shot.x*targetWidth/2 + ((j + 1)*targetSpacing + (j + 0.5)*targetWidth) - 0.5,
                y: shot.y*targetWidth/2,
                value: shot.value
            }, shot.value === '1' ? this.style.hitMarkerColor : this.style.missedMarkerColor);
        }

        ++i;
    }
};

ISSFSilhouetteFinalPistolShotRenderer.prototype.getShotScale = function () {
    return this.scale*this.rect.width;
};
