var TargetRenderer = require('./TargetRenderer');
var RingTargetRenderer = require('./RingTargetRenderer');

function ISSFSilhouetteFinalPistolTargetRenderer() {
    TargetRenderer.prototype.constructor.apply(this);
}

ISSFSilhouetteFinalPistolTargetRenderer.prototype = new TargetRenderer();
ISSFSilhouetteFinalPistolTargetRenderer.prototype.constructor = ISSFSilhouetteFinalPistolTargetRenderer;
ISSFSilhouetteFinalPistolTargetRenderer.TARGET_SPACING = 0.02;
module.exports = ISSFSilhouetteFinalPistolTargetRenderer;

// --- External API ---
ISSFSilhouetteFinalPistolTargetRenderer.prototype.setTarget = function (target) {
    this.renderer.setTarget(target);

    return this;
};

ISSFSilhouetteFinalPistolTargetRenderer.prototype.setStyle = function (style) {
    var ret = TargetRenderer.prototype.setStyle.apply(this, [style]);
    this.renderer.setStyle(style);

    return ret;
};

ISSFSilhouetteFinalPistolTargetRenderer.prototype.setContext = function (context) {
    var ret = TargetRenderer.prototype.setContext.apply(this, [context]);
    this.renderer.setContext(context);

    return ret;
};

// --- Internal API ---
ISSFSilhouetteFinalPistolTargetRenderer.prototype.initialize = function () {
    TargetRenderer.prototype.initialize.apply(this);

    this.renderer = new RingTargetRenderer()
        .setScale(1);
};

ISSFSilhouetteFinalPistolTargetRenderer.prototype.render = function () {
    this.context.fillStyle = this.style.backColor;
    this.context.fillRect(this.rect.x, this.rect.y, this.rect.width, this.rect.height);

    var width = this.rect.width;
    var targetSpacing = ISSFSilhouetteFinalPistolTargetRenderer.TARGET_SPACING;
    var targetWidth = width*(1 - 6*targetSpacing)/5;

    // draw each of the five targets
    for (var i = 0; i < 5; ++i) {
        var rect = {
            x: this.rect.x + targetWidth*i + width*targetSpacing*(i + 1),
            y: this.rect.y,
            width: targetWidth,
            height: this.rect.height
        };

        this.renderer.setRect(rect);
        this.renderer.render();
    }
};
