module.exports = {
    drawFrame: drawFrame,
    setFont: setFont,
    strokeFrame: strokeFrame
};

function setFont(ctx, text, width, height) {
    var fontName = "arial";
    var refSize = 10;

    // get reference text width
    ctx.font = refSize + "px " + fontName;
    var refTextWidth = ctx.measureText(text).width;

    // calculate maximum textHeight
    var textHeight = Math.min(height, width/refTextWidth * refSize);

    // assemble font name
    ctx.font = textHeight + "px " + fontName;
}

function strokeFrame(ctx, rect, color) {
    var pixelRatio = window.devicePixelRatio || 1;

    ctx.strokeStyle = color;
    ctx.lineWidth = 1*pixelRatio;
    ctx.strokeRect(rect.x, rect.y, rect.width, rect.height);
}

function drawFrame(ctx, rect, frontColor, backColor) {
    ctx.fillStyle = backColor;
    ctx.fillRect(rect.x, rect.y, rect.width, rect.height);

    strokeFrame(ctx, rect, frontColor);
}
