var LiveShot = require('../../../index');

var width = 300;
var height = 400;
var pixelRatio = window.devicePixelRatio || 1;

var canvas = document.createElement('canvas');
canvas.width = width*pixelRatio;
canvas.height = height*pixelRatio;
canvas.style.width = width + 'px';
canvas.style.height = height + 'px';

document.body.appendChild(canvas);

var ctx = canvas.getContext('2d');
var rect = {x:0, y:0, width:width*pixelRatio, height:height*pixelRatio};

var builder = new LiveShot.CardBuilder()
    .setLane('1')
    .setName('Martin Vonheim Larsen')
    .setClub('Rygge')
    .setClassName('4')
    .setCategory('A')
    .setTargetID('INT_ISSF_SILHOUETTE_FINAL_PISTOL')
    .setGaugeSize(5600/(500000*0.88*5))
    .setSeriesName('Ligg');

builder.resetShots()
    .setSeriesSum('5')
    .setTotalSum('5');

for (var i = 0; i < 4; ++i) {
    var gauge = 5600/(500000*0.88*5);
    var r = Math.random()*0.3;
    var theta = Math.random()*2*Math.PI;
    var x = r*Math.cos(theta);
    var y = r*Math.sin(theta);
    var value = (r - gauge/2 <= 4/25) ? '1' : '0';

    builder.addShotData(x, y, value);
}

var renderer = new LiveShot.MegalinkCardRenderer()
    .setContext(ctx)
    .setRect(rect)
    .setCard(builder.getCard())
    .render();
