var LiveShot = require('../../../index');

var width = window.innerWidth;
var height = window.innerHeight;
var pixelRatio = window.devicePixelRatio || 1;

var canvas = document.createElement('canvas');
canvas.width = width*pixelRatio;
canvas.height = height*pixelRatio;
canvas.style.width = width + 'px';
canvas.style.height = height + 'px';

document.body.appendChild(canvas);

var ctx = canvas.getContext('2d');

function getRect() {
    return {x:0, y:0, width:window.innerWidth*pixelRatio, height:window.innerHeight*pixelRatio};
}

var builder = new LiveShot.CardBuilder()
    .setLane('1')
    .setName('Martin Vonheim Larsen')
    .setClub('Rygge')
    .setClassName('4')
    .setCategory('A')
    .setTargetID('NO_DFS_15M')
    .setGaugeSize('0.0695')
    .setSeriesName('Ligg');

var r = Math.random();
var value = Math.floor(Math.random() * 100)/10;
var seriesSum = Math.floor(Math.random()*100);
var totalSum = Math.floor(2.5*seriesSum);

builder.resetShots()
    .addShotData(Math.random()*r - .1, Math.random()*r - .1, value)
    .addShotData(Math.random()*r - .1, Math.random()*r - .1, value)
    .addShotData(Math.random()*r - .1, Math.random()*r - .1, value)
    .addShotData(Math.random()*r - .1, Math.random()*r - .1, value)
    .addShotData(Math.random()*r - .1, Math.random()*r - .1, value)
    .addShotData(Math.random()*r - .1, Math.random()*r - .1, value)
    .addShotData(Math.random()*r - .1, Math.random()*r - .1, value)
    .setSeriesSum(seriesSum)
    .setTotalSum(totalSum);

var cards = [];

for (var i = 0; i < 10; ++i) {
    cards.push(builder.setLane(i+1).getCard());
}

var range = new LiveShot.RangeBuilder()
    .setName('15M')
    .setHost('Rygge SKL')
    .setRelay('1')
    .getRange();

var renderer = new LiveShot.MegalinkRangeRenderer()
    .setContext(ctx)
    .setRect(getRect())
    .setRange(range)
    .setCards(cards);
renderer.render();

window.onresize = function () {
    var rect = getRect();

    canvas.width = rect.width;
    canvas.height = rect.height;
    canvas.style.width = rect.width/pixelRatio + "px";
    canvas.style.height = rect.height/pixelRatio + "px";
    renderer.setRect(rect).render();
};
